// Include the library code
#include <LiquidCrystal.h>
#include <rotary.h>

//Setup some items
#define W_CLK 8   // Pin 8 - connect to AD9850 module word load clock pin (CLK)
#define FQ_UD 9   // Pin 9 - connect to freq update pin (FQ)
#define DATA 10   // Pin 10 - connect to serial data load pin (DATA)
#define RESET 11  // Pin 11 - connect to reset pin (RST) 
#define pulseHigh(pin) {digitalWrite(pin, HIGH); digitalWrite(pin, LOW); }
Rotary r = Rotary(2,3); // sets the pins the rotary encoder uses.  Must be interrupt pins.
LiquidCrystal lcd(12, 13, 7, 6, 5, 4); // I used an odd pin combination because I need pin 2 and 3 for the interrupts.
int_fast32_t rx=1750000; // Starting frequency of VFO
int_fast32_t rx2=1; // variable to hold the updated frequency
int_fast32_t increment = 500; // starting VFO update increment in HZ.
int_fast32_t IFfrec=10700000;
int buttonstate = 0;
int buttonstateTX = 1; 
int TX = 1;    // для устранения мерцания при передаче
int TX2 = 1;
int s = 1 ;  // для приветствие
String hertz = "AM   500Hz";
int  hertzPosition = 0;   // начало второй строки
byte ones,tens,hundreds,thousands,tenthousands,hundredthousands,millions ;  //Placeholders

//добавил кнопку передача А1
void setup() {
  pinMode(A0,INPUT); // Connect to a button that goes to GND on push
  digitalWrite(A0,HIGH);
  pinMode(A1,INPUT);
  digitalWrite(A1,HIGH);
  lcd.begin(16, 2);
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();
  pinMode(FQ_UD, OUTPUT);
  pinMode(W_CLK, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(RESET, OUTPUT); 
  pulseHigh(RESET);
  pulseHigh(W_CLK);
  pulseHigh(FQ_UD);  // this pulse enables serial mode on the AD9850 - Datasheet page 12.
  lcd.setCursor(hertzPosition,1);    
  lcd.print(hertz);
}

/*
//добавить кнопку передача А1
void setup() {
  pinMode(A0,INPUT); // Connect to a button that goes to GND on push
  digitalWrite(A0,HIGH);
  lcd.begin(16, 2);
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();
  pinMode(FQ_UD, OUTPUT);
  pinMode(W_CLK, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(RESET, OUTPUT); 
  pulseHigh(RESET);
  pulseHigh(W_CLK);
  pulseHigh(FQ_UD);  // this pulse enables serial mode on the AD9850 - Datasheet page 12.
  lcd.setCursor(hertzPosition,1);    
  lcd.print(hertz);
}
*/

ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){rx=rx+increment;}
    else {rx=rx-increment;};       
      //if (rx >=3700000){rx=rx2;}; // UPPER VFO LIMIT
      //if (rx <=1600000){rx=rx2;}; // LOWER VFO LIMIT
  }
}

/*
// установка границ перестройки 
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){rx=rx+increment;}
    else {rx=rx-increment;};       
      if (rx >=3700000){rx=1601000;}; // UPPER VFO LIMIT
      if (rx <=1600000){rx=3700000;}; // LOWER VFO LIMIT
  }
}
*/


// frequency calc from datasheet page 8 = <sys clock> * <frequency tuning word>/2^32
void sendFrequency(double frequency) {  
  int32_t freq = frequency * 4294967295/125000220;  // note 125 MHz clock on 9850.  You can make 'slight' tuning variations here by adjusting the clock frequency.
  for (int b=0; b<4; b++, freq>>=8) {    
    tfr_byte(freq & 0xFF);
  }
  tfr_byte(0x000);   // Final control byte, all 0 for 9850 chip
  pulseHigh(FQ_UD);  // Done!  Should see output
}
// transfers a byte, a bit at a time, LSB first to the 9850 via serial DATA line
void tfr_byte(byte data)
{
  for (int i=0; i<8; i++, data>>=1) {
    digitalWrite(DATA, data & 0x01);
    pulseHigh(W_CLK);   //after each bit sent, CLK is pulsed high
  }
}


/*
void setincrement(){
  if(increment == 10){increment = 50; hertz = "50 Hz"; hertzPosition=5;}
  else if (increment == 50){increment = 100;  hertz = "100 Hz"; hertzPosition=4;}
  else if (increment == 100){increment = 500; hertz="500 Hz"; hertzPosition=4;}
  else if (increment == 500){increment = 1000; hertz="1 Khz"; hertzPosition=6;}
  else if (increment == 1000){increment = 2500; hertz="2.5 Khz"; hertzPosition=4;}
  else if (increment == 2500){increment = 5000; hertz="5 Khz"; hertzPosition=6;}
  else if (increment == 5000){increment = 10000; hertz="10 Khz"; hertzPosition=5;}
  else if (increment == 10000){increment = 100000; hertz="100 Khz"; hertzPosition=4;}
  else if (increment == 100000){increment = 1000000; hertz="1 Mhz"; hertzPosition=6;}  
  else{increment = 10; hertz = "10 Hz"; hertzPosition=5;};  
   lcd.setCursor(0,1);
   lcd.print("                ");
   lcd.setCursor(hertzPosition,1); 
   lcd.print(hertz); 
   delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};
*/
void setincrement(){
  if(increment == 100){increment = 500; hertz = "AM   500 Hz"; hertzPosition=0;}
  //else if (increment == 50){increment = 100;  hertz = "100 Hz"; hertzPosition=4;}
  //else if (increment == 100){increment = 500; hertz="500 Hz"; hertzPosition=4;}
  else if (increment == 500){increment = 1000; hertz="AM     1 Khz"; hertzPosition=0;}
  //else if (increment == 1000){increment = 2500; hertz="2.5 Khz"; hertzPosition=4;}
  //else if (increment == 2500){increment = 5000; hertz="5 Khz"; hertzPosition=6;}
  //else if (increment == 5000){increment = 10000; hertz="10 Khz"; hertzPosition=5;}
  else if (increment == 1000){increment = 100000; hertz="AM   100 Khz"; hertzPosition=0;}
  //else if (increment == 100000){increment = 1000000; hertz="1 Mhz"; hertzPosition=6;}  
  else{increment = 100; hertz = "AM   100 Hz"; hertzPosition=0;};  
   lcd.setCursor(0,1);
   lcd.print("                ");
   lcd.setCursor(hertzPosition,1); 
   lcd.print(hertz); 
   delay(250); // Adjust this delay to speed up/slow down the button menu scroll speed.
};
//сдвинуты показания частоты для индикиции рх тх, забиты десятки и сотни герц
void showFreq(){
    millions = int(rx/1000000);
    hundredthousands = ((rx/100000)%10);
    tenthousands = ((rx/10000)%10);
    thousands = ((rx/1000)%10);
    hundreds = ((rx/100)%10);
    tens = ((rx/10)%10);
    ones = ((rx/1)%10);
    lcd.setCursor(0,0);
    lcd.print("                ");
   if (millions > 9){lcd.setCursor(1,0);}
   else{lcd.setCursor(5,0);}
    //lcd.print("     ");
    lcd.print(millions);
    lcd.print(".");
    lcd.print(hundredthousands);
    lcd.print(tenthousands);
    lcd.print(thousands);
    lcd.print(".");
    lcd.print(hundreds);
  //  lcd.print(tens);
  //  lcd.print(ones);
    lcd.print(" Mhz");  
};
/*
void loop() {                   // работает как гетеродин приемника
  if (rx != rx2){    
        showFreq();
        rx = rx + IFfrec ;
        sendFrequency(rx);
        rx = rx + rx - IFfrec ;
        rx2 = rx;
      } 
      
  buttonstate = digitalRead(A0);
  if(buttonstate == LOW) {
        setincrement();        
    };
    buttonstateTX = digitalRead(A1);
  if(buttonstateTX == LOW) {
        lcd.setCursor(0,0);
        //lcd.print("  ");
        lcd.print("TX ");}
   else{lcd.setCursor(0,0); 
        //lcd.print("  "); 
        lcd.print("RX ");};
  
}
*/
/*
void loop() {
  if (rx != rx2) {    
        showFreq();
        buttonstateTX = digitalRead(A1);
    if (buttonstateTX == LOW) {
       lcd.setCursor(0,0);
       //lcd.print(" ");
        lcd.print("TX ");
       sendFrequency(rx);
        rx2 = rx;
       }
   else {lcd.setCursor(0,0);
        //lcd.print("  ");
        lcd.print("RX");
        rx = rx + IFfrec ;
        sendFrequency(rx);
        rx = rx + rx - IFfrec ;
        rx2 = rx;
         }
  }  
 buttonstate = digitalRead(A0);
  if(buttonstate == LOW) {
        setincrement();        
  }
 
   buttonstateTX = digitalRead(A1);
  if(buttonstateTX == LOW) {
   rx2 = rx + 1;
  }
  }
  */
  
void loop() {
  //приветствие
  if(s == 1){
    delay(500);
    //lcd.setCursor(0.1);
    lcd.print("                ");
    lcd.setCursor(0,0);
    lcd.print("  RAFINAD 2013  ");
    delay(1500);
  s = 0;
  }
  if (rx != rx2) {    
        showFreq();
        buttonstateTX = digitalRead(A1);
    if (buttonstateTX == LOW) {
       lcd.setCursor(0,0);
       //lcd.print(" ");
        lcd.print("TX ");
       sendFrequency(rx);
        rx2 = rx;
       }
   else {lcd.setCursor(0,0);
        //lcd.print("  ");
        lcd.print("RX");
        rx = rx + IFfrec ;
        sendFrequency(rx);
        rx = rx + rx - IFfrec ;
        rx2 = rx;
         }
  }  
 buttonstate = digitalRead(A0);
  if(buttonstate == LOW) {
        setincrement();        
  }
 
   buttonstateTX = digitalRead(A1);
   TX = buttonstateTX;
   if (TX != TX2) {
   rx2 = rx + 1;
   TX2 = TX;
   }
}
